#!/bin/python

import random
import subprocess
import time

statenames=['AL', 'AK', 'AZ', 'AR', 'CA', 'CO', 'CT', 'DE', 'DC', 'FL', 'GA', 'HI', 'ID', 'IL', 'IN', 'IA', 'KS', 'KY', 'LA', 'ME', 'MD', 'MA', 'MI', 'MN', 'MS', 'MO', 'MT', 'NE', 'NV', 'NH', 'NJ', 'NM', 'NY', 'NC', 'ND', 'OH', 'OK', 'OR', 'PA', 'RI', 'SC', 'SD', 'TN', 'TX', 'UT', 'VT', 'VA', 'WA', 'WV', 'WI', 'WY']

def fullrecalc():
    probs=intradelist(statenames)
    return montehyp(probs, [], [])


def getfromintrade(state):
#    print "Getting for", state
    fullstate="\""+name[state]+"\""
#    print "Getting for", fullstate
    obamap=subprocess.Popen([r"perl", "./getval.pl", fullstate], stdout=subprocess.PIPE).communicate()[0]
 #   print obamap, "\n"
    return float(obamap)
#    tup=prob[state]
#    return float(tup[0])/(sum(tup))

def intradelist(statelist):
    probs={}
    for i in statelist:
        probs[i]=getfromintrade(i)
    return probs

def simhyp(states, probs, obamastates, mccainstates):
    dvotes=0
    rvotes=0
    dstates=[]
    rstates=[]
    for i in states:
#        print i, ":"
        p=probs[i]
#        print p
        if random.random()<p:
            dvotes+=votes[i]
            dstates.append(i)
        else:
            rvotes+=votes[i]
            rstates.append(i)

    for i in obamastates:
        dvotes+=votes[i]
        dstates.append(i)
    for i in mccainstates:
        rvotes+=votes[i]
        rstates.append(i)
#    if rvotes==270:
#        print " ".join(rstates)
    if dvotes+rvotes != 538:
        return ["ERROR", [dvotes, rvotes], [dstates, rstates]]
    if dvotes>=270 and rvotes<270:
        return ["OBAMA", [dstates, rstates]]
    if rvotes>=270 and dvotes<270:
        return ["MCCAIN", [dstates, rstates]]
    if dvotes==269 and rvotes==269:
        return ["TIE", [dstates, rstates]]
    return ["ERROR", [dvotes, rvotes], [dstates, rstates]]
    

def sim(states, probs):
    dvotes=0
    rvotes=0
    dstates=[]
    rstates=[]
    for i in states:
#        print i, ":"
        p=probs[i]
#        print p
        if random.random()<p:
            dvotes+=votes[i]
            dstates.append(i)
        else:
            rvotes+=votes[i]
            rstates.append(i)
    if dvotes+rvotes != 538:
        return ["ERROR", [dvotes, rvotes], [dstates, rstates]]
    if dvotes>=270 and rvotes<270:
        return ["OBAMA", [dstates, rstates]]
    if rvotes>=270 and dvotes<270:
        return ["MCCAIN", [dstates, rstates]]
    if dvotes==269 and rvotes==269:
        return ["TIE", [dstates, rstates]]
    return ["ERROR", [dvotes, rvotes], [dstates, rstates]]

def montehyp(realprobs, obamastates, mccainstates):
    dwins=0
    rwins=0
    ties=0
    errors=0

    probs=dict(realprobs)
    stateslist=list(statenames)
    stateslist.sort()
    obamastates=list(set(obamastates))
    mccainstates=list(set(mccainstates))

    nonstates=[]
    for i in obamastates+mccainstates:
        if not (i in name):
            nonstates.append(i)
    if nonstates:
        return "The following are not states."+str(nonstates)

    if(set(obamastates).intersection(set(mccainstates))):
        return "Duplicate states in lists."

    for i in list(set(obamastates)):
        probs[i]=1
    for i in list(set(mccainstates)):
        probs[i]=0

    ev=[0.0 for i in xrange(539)]
    for i in xrange(539):
        ev[i]=0.0
    ev[0]=1.0
    for j in stateslist:
#        temp=list(ev)
        for i in xrange(538,-1,-1):
            if votes[j]<=i:
                ev[i]=probs[j]*ev[i-votes[j]]+(1-probs[j])*ev[i]
            else:
                ev[i]*=1-probs[j]

    pdem=100.0*sum(ev[270:])
    prep=100.0*sum(ev[:269])
    ptie=100.0*ev[269]

#    print "Obama: ", str(round(pdem,3))
#    print "McCain:", str(round(prep,3))
#    print "Tie:   ", str(round(ptie,3))

    log=open("odds.log", 'a')
    print >>log, time.time(), str(round(pdem,1)), str(round(prep, 1)), str(round(ptie, 1))
    log.close()

    dstring="Obama:  <span style=\"color: #0000FF\">"+str(round(pdem,1))+"</span>"
    rstring="McCain: <span style=\"color: #FF0000\">"+str(round(prep, 1))+"</span>"
    tstring="Tie: <span style=\"color: #888888\">"+str(round(ptie, 1))+"</span>"
    

    if pdem>prep:
        if pdem>ptie:
            if prep>ptie:
                return dstring+"\n"+rstring+"\n"+tstring
            else:
                return dstring+"\n"+tstring+"\n"+rstring
        else:
            return tstring+"\n"+dstring+"\n"+rstring
    else:
        if prep>ptie:
            if pdem>ptie:
                return rstring+"\n"+dstring+"\n"+tstring
            else:
                return rstring+"\n"+tstring+"\n"+dstring
        else:
            return tstring+"\n"+rstring+"\n"+dstring

        


def montehyp_old(numsims, probs, obamastates, mccainstates):
    dwins=0
    rwins=0
    ties=0
    errors=0

    stateslist=list(statenames)
    stateslist.sort()
    obamastates=list(set(obamastates))
    mccainstates=list(set(mccainstates))

    nonstates=[]
    for i in obamastates+mccainstates:
        if not (i in name):
            nonstates.append(i)
    if nonstates:
        return "The following are not states."+str(nonstates)

    if(set(obamastates).intersection(set(mccainstates))):
        return "Duplicate states in lists."
    for i in list(set(obamastates).union(set(mccainstates))):
        stateslist.remove(i)

    for n in xrange(numsims):
        outcome=simhyp(stateslist, probs, obamastates, mccainstates)
        if outcome[0]=="OBAMA":
            dwins+=1
        if outcome[0]=="MCCAIN":
            rwins+=1
        if outcome[0]=="TIE":
            ties+=1
        if outcome[0]=="ERROR":
            errors+=1
    if errors:
        return "The totals didn't add up to 538!  Something is horribly wrong."
    pdem=100*float(dwins)/numsims
    prep=100*float(rwins)/numsims
    ptie=100*float(ties)/numsims
    print "Obama: ", round(pdem,2)
    print "McCain:", round(prep,2)
    print "Tie:   ", round(ptie,2)

    log=open("odds.log", 'a')
    print >>log, time.time(), str(round(pdem,1)), str(round(prep, 1)), str(round(ptie, 1))
    log.close()

    dstring="Obama:  <span style=\"color: #0000FF\">"+str(round(pdem,1))+"</span>"
    rstring="McCain: <span style=\"color: #FF0000\">"+str(round(prep, 1))+"</span>"
    tstring="Tie: <span style=\"color: #888888\">"+str(round(ptie, 1))+"</span>"

#    return ("Obama:  <span style=\"color: #0000FF\">"+str(round(pdem, 1))+"</span>"+
#            "\nMcCain: <span style=\"color: #FF0000\">"+str(round(prep, 1))+"</span>"+
#            "\nTie:    <span style=\"color: #888888\">"+str(round(ptie, 1)))+"</span>"



    if pdem>prep:
        if pdem>ptie:
            if prep>ptie:
                return dstring+"\n"+rstring+"\n"+tstring
            else:
                return dstring+"\n"+tstring+"\n"+rstring
        else:
            return tstring+"\n"+dstring+"\n"+rstring
    else:
        if prep>ptie:
            if pdem>ptie:
                return rstring+"\n"+dstring+"\n"+tstring
            else:
                return rstring+"\n"+tstring+"\n"+dstring
        else:
            return tstring+"\n"+rstring+"\n"+dstring

def monte(numsims, states, probs):
    dwins=0
    rwins=0
    ties=0
    errors=0
    for n in xrange(numsims):
        outcome=sim(states, probs)
        if outcome[0]=="OBAMA":
            dwins+=1
        if outcome[0]=="MCCAIN":
            rwins+=1
        if outcome[0]=="TIE":
            ties+=1
        if outcome[0]=="ERROR":
            errors+=1
    if errors:
        print "SOME ERROR RESULTS."
    pdem=100*float(dwins)/numsims
    prep=100*float(rwins)/numsims
    ptie=100*float(ties)/numsims
    print "OBAMA:  "+str(round(pdem, 2))
    print "MCCAIN: "+str(round(prep, 2))
    print "TIE:    "+str(round(ptie, 2))

    return



# [democrat, republican]

prob={}
votes={}
name={}



prob['AL'] = [3.0, 95.0]
prob['AK'] = [6.0, 93.5]
prob['AZ'] = [5.0, 95.0]
prob['AR'] = [8.0, 92.0]
prob['CA'] = [93.5, 5.5]
prob['CO'] = [68.0, 32.1]
prob['CT'] = [91.0, 5.5]
prob['DE'] = [95.0, 7.0]
prob['DC'] = [97.0, 3.0]
prob['FL'] = [54.0, 48.0]
prob['GA'] = [12.0, 89.0]
prob['HI'] = [97.7, 2.3]
prob['ID'] = [3.0, 97.0]
prob['IL'] = [96.0, 4.0]
prob['IN'] = [38.0, 62.0]
prob['IA'] = [84.0, 16.0]
prob['KS'] = [6.0, 94.0]
prob['KY'] = [7.5, 94.1]
prob['LA'] = [10.0, 91.0]
prob['ME'] = [89.8, 10.9]
prob['MD'] = [95.0, 7.3]
prob['MA'] = [96.3, 3.7]
prob['MI'] = [78.9, 20.1]
prob['MN'] = [83.8, 17.1]
prob['MS'] = [6.5, 93.0]
prob['MO'] = [33.3, 68.0]
prob['MT'] = [16.0, 89.8]
prob['NE'] = [10.0, 97.5]
prob['NV'] = [54.4, 45.0]
prob['NH'] = [60.1, 36.5]
prob['NJ'] = [92.4, 8.1]
prob['NM'] = [77.0, 20.1]
prob['NY'] = [95.8, 5.0]
prob['NC'] = [45.3, 51.0]
prob['ND'] = [15.0, 90.0]
prob['OH'] = [53.0, 47.0]
prob['OK'] = [5.0, 96.0]
prob['OR'] = [90.0, 8.9]
prob['PA'] = [80.0, 21.0]
prob['RI'] = [95.0, 5.0]
prob['SC'] = [9.0, 92.5]
prob['SD'] = [10.0, 93.0]
prob['TN'] = [9.9, 90.0]
prob['TX'] = [7.5, 93.0]
prob['UT'] = [2.0, 98.0]
prob['VT'] = [92.5, 7.5]
prob['VA'] = [54.5, 44.0]
prob['WA'] = [88.0, 10.1]
prob['WV'] = [17.0, 83.1]
prob['WI'] = [80.0, 22.6]
prob['WY'] = [4.2, 95.8]

votes['AL'] = 9
votes['AK'] = 3
votes['AZ'] = 10
votes['AR'] = 6
votes['CA'] = 55
votes['CO'] = 9
votes['CT'] = 7
votes['DE'] = 3
votes['DC'] = 3
votes['FL'] = 27
votes['GA'] = 15
votes['HI'] = 4
votes['ID'] = 4
votes['IL'] = 21
votes['IN'] = 11
votes['IA'] = 7
votes['KS'] = 6
votes['KY'] = 8
votes['LA'] = 9
votes['ME'] = 4
votes['MD'] = 10
votes['MA'] = 12
votes['MI'] = 17
votes['MN'] = 10
votes['MS'] = 6
votes['MO'] = 11
votes['MT'] = 3
votes['NE'] = 5
votes['NV'] = 5
votes['NH'] = 4
votes['NJ'] = 15
votes['NM'] = 5
votes['NY'] = 31
votes['NC'] = 15
votes['ND'] = 3
votes['OH'] = 20
votes['OK'] = 7
votes['OR'] = 7
votes['PA'] = 21
votes['RI'] = 4
votes['SC'] = 8
votes['SD'] = 3
votes['TN'] = 11
votes['TX'] = 34
votes['UT'] = 5
votes['VT'] = 3
votes['VA'] = 13
votes['WA'] = 11
votes['WV'] = 5
votes['WI'] = 10
votes['WY'] = 3

name['AL'] = "ALABAMA"
name['AK'] = "ALASKA"
name['AZ'] = "ARIZONA"
name['AR'] = "ARKANSAS"
name['CA'] = "CALIFORNIA"
name['CO'] = "COLORADO"
name['CT'] = "CONNECTICUT"
name['DE'] = "DELAWARE"
name['DC'] = "DISTRICTOFCOLUMBIA"
name['FL'] = "FLORIDA"
name['GA'] = "GEORGIA"
name['HI'] = "HAWAII"
name['ID'] = "IDAHO"
name['IL'] = "ILLINOIS"
name['IN'] = "INDIANA"
name['IA'] = "IOWA"
name['KS'] = "KANSAS"
name['KY'] = "KENTUCKY"
name['LA'] = "LOUISIANA"
name['ME'] = "MAINE"
name['MD'] = "MARYLAND"
name['MA'] = "MASSACHUSETTS"
name['MI'] = "MICHIGAN"
name['MN'] = "MINNESOTA"
name['MS'] = "MISSISSIPPI"
name['MO'] = "MISSOURI"
name['MT'] = "MONTANA"
name['NE'] = "NEBRASKA"
name['NV'] = "NEVADA"
name['NH'] = "NEWHAMPSHIRE"
name['NJ'] = "NEWJERSEY"
name['NM'] = "NEWMEXICO"
name['NY'] = "NEWYORK"
name['NC'] = "NTH.CAROLINA"
name['ND'] = "NTH.DAKOTA"
name['OH'] = "OHIO"
name['OK'] = "OKLAHOMA"
name['OR'] = "OREGON"
name['PA'] = "PENNSYLVANIA"
name['RI'] = "RHODEISLAND"
name['SC'] = "STH.CAROLINA"
name['SD'] = "STH.DAKOTA"
name['TN'] = "TENNESSEE"
name['TX'] = "TEXAS"
name['UT'] = "UTAH"
name['VT'] = "VERMONT"
name['VA'] = "VIRGINIA"
name['WA'] = "WASHINGTON"
name['WV'] = "WESTVIRGINIA"
name['WI'] = "WISCONSIN"
name['WY'] = "WYOMING"

